﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
import argparse
import urllib
import re
import os
import codecs
os.chdir(os.path.dirname(os.path.abspath(__file__)))
def detexrepl(zz):
	zz = re.sub(r"\\_",r"_",zz) 
	zz = re.sub(r"\\textasciicircum",r"^",zz) 
	zz = re.sub(r"\\textasciitilde",r"~",zz) 
	zz = re.sub(r"\\{",r"&#123;",zz) 
	zz = re.sub(r"\\}",r"&#125;",zz)
	zz = re.sub(r"\\%",r"%",zz) 
	zz = re.sub(r"\\"+"\$","\$",zz) 
	zz = re.sub(r"\#",r"#",zz) 
	zz = re.sub(r"\\&",r"&amp;",zz) 
	zz = re.sub(r"\\textbackslash",r"&#92;",zz) 
	zz = re.sub(r"\\textasteriskcentered",r"*",zz) 
	zz = re.sub(r"\\textbar",r"|",zz) 
	zz = re.sub("''",'"',zz)
	#zz = re.sub(r"\\\\\*","",zz)
	zz = re.sub(r"<","&lt;",zz)
	zz = re.sub(r">","&gt;",zz)
	return zz
def rexrepl(zz):
	zz = zz.replace('\\',r'\\')
	zz = zz.replace('^',r'\^')
	#zz = zz.replace('$',r'\$')
	zz = zz.replace('|',r'\|')
	zz = zz.replace('(',r'\(')
	zz = zz.replace('[',r'\[')
	zz = zz.replace(']',r'\]')
	zz = zz.replace(')',r'\)')
	zz = zz.replace('+',r'\+')
	zz = zz.replace('*',r'\*')
	zz = zz.replace('?',r'\?')
	return zz
rht = re.compile(ur"\\url\{.+?\}")
rqu = re.compile(ur"^\\qu\{", re.I | re.U)
rtour = re.compile(ur"^\\tour", re.I | re.U)
ran = re.compile(ur"^\\an\{", re.I | re.U)
rza = re.compile(ur"^\\za\{", re.I | re.U)
rnza = re.compile(ur"^\\nza\{", re.I | re.U)
rco = re.compile(ur"^\\co\{", re.I | re.U)
rsos = re.compile(ur"^\\sos\{", re.I | re.U)
rso = re.compile(ur"^\\so\{", re.I | re.U)
rau = re.compile(ur"^\\au\{", re.I | re.U)
raus = re.compile(ur"^\\aus\{", re.I | re.U)
rperc = re.compile(ur"(%[0-9a-fA-F]{2})+")
rtextbf = re.compile(ur"\\textbf\{.+?\}")
remph = re.compile(ur"\\emph\{.+?\}")
racc = re.compile(ur"\\acc\{.+?\}")
rtextsc = re.compile(ur"\\textsc\{.+?\}")
rsetcounter = re.compile(ur'\\setcounter\{Questions\}\{'+ur'[0-9]+'+ur'\}')
ritem = re.compile(ur'\\item ?.*?(?=(( ?\\item)|(\}$)|(\\\\\*)|($)|( ?\\end)))')
rgraph = re.compile(ur'\\includegraphics(\[.*?\])?\{.*?\}')
rgraphwidth = re.compile(ur'width=[0-9]+ ?[a-z]+?(?=[,\]])')
rgraphheight = re.compile(ur'height=[0-9]+ ?[a-z]+?(?=[,\]])')
parser = argparse.ArgumentParser()
parser.add_argument("filename")
parser.add_argument("-s", "--spoiler", help="html spoilers",
                    action="store_true")
parser.add_argument("-lj", "--livejournal", help="livejournal spoilers",
                    action="store_true")
args = parser.parse_args()
filepref="<html>\n<body>\n<style>div {margin: 1em 0 1em 0; width: 33em;} .sc{font-variant: small-caps;} li{margin-left: 2em;} ol{margin: 0; padding: 0;}</style>\n"
mode = "standard"
spwrap = u""
br = u"<br/>\n"
presp = u""
presp2 = u""
def ppresp():
	return (presp + spwrap + presp2)
def pposp():
	return (posp + spwrap + posp2)
posp = u""
posp2 = u""
#prevline = ""
fakediv = u""
div = u"<div>"
div2 = u"</div>"
if args.spoiler:
	mode = "standard + spoilers"
	filepref = filepref + u"""<style>.spoiler {display: none;}</style>
<script type="text/javascript">function showSpoiler(obj){
var nextS=obj.nextSibling;
nextS.style.display=nextS.style.display=='inline'?'none':'inline';
obj.innerHTML='';
}</script>"""
	presp = u'<a href="\u0023" onclick="showSpoiler(this); return false;">[показать]</a><'
	presp2 = u' class="spoiler">'
	spwrap = u'span'
	posp = u'</'
	posp2 = u'>'
	fakediv = u'<div style="width: 0px; height:0px; margin: 0; padding: 0;"></div>'
if args.livejournal:
	mode = "livejournal"
	div = u""
	div2 = u""
	filepref = u""
	presp = u"<" #u"<lj-spoiler>"
	spwrap = u"lj-spoiler"
	presp2 = u">"
	posp = u"</" #u'</lj-spoiler>'
	posp2 = u">"
	fakediv = u'<div style="width: 0px; height:0px; margin: 0; padding: 0;"></div>'
	br = u"\n"
def proc(s):
	global presp
	global posp
	global spwrap
	global mode
	global br
	#parag = False
	passitem = False
	spoiled = False
	qcount = 1
	tcount = 1
	fout = os.path.splitext(s)[0] + ".html"
	# print(fout)
	with codecs.open(fout, encoding='utf-8', mode='w') as fw:
		fw.write(filepref)
		with codecs.open(s, encoding='utf-8', mode='r') as fo:
			for line in fo:
				pref = ""
				postf = ""
				item = False
				notlast = False
				st = re.sub(u'\ufeff','',line) #чистим от BOM
				st = st.rstrip()
				if re.search(ur'\\input\{',st): #чистим от инпутов
					st = u""
				if re.search(ur'(?<!=\\)%',st): #чистим от комментов
					st = re.sub(ur"(?<!=\\)%.*$","",st)
				if re.search(ur'\\((begin)|(end))\{document',st): #чистим от бегин-энда
					st = u""
				if st[-3:] == r'\\*': # счётчик переноса строки
					notlast = True
				st = detexrepl(st)
				if re.search(ur'\\begin\{enumerate',st):
					st = re.sub(ur'\\begin\{enumerate\}',u'<ol style="display: inline;">',st)
				if re.search(ur'\\end\{enumerate',st):
					st = re.sub(ur'\\end\{enumerate\}\}?','',st)
				matches = rht.finditer(st)
				results = [match.group(0) for match in matches]
				for x in results:
					st = re.sub(rexrepl(x),r'<a href="'+x[5:-1]+'">'+x[5:-1]+"</a>",st, re.U | re.I)
				if re.search(ur'\\item',st):
					item = True
					passitem = True
					matches = ritem.finditer(st)
					results = [match.group(0) for match in matches]
					for x in results:
						st = re.sub(rexrepl(x),re.sub(ur'\\item ?',u'<li>',x)+u'</li>',st)
					st = re.sub(ur' +</li>', u'</li>', st)
					# st = u"<li>" + re.sub('\s*?\\\\item\s*?','',st)
				if (item == False) and (passitem == True):
					passitem = False
					st = u"</ol>" + pposp() + fakediv + st
				matches = rsetcounter.finditer(st)
				results = [match.group(0) for match in matches]
				for x in results:
					qcount = int(x[23:-1])
					print("Counter set to: "+str(qcount))
					st = ""

				
				matches = rtextbf.finditer(st)
				results = [match.group(0) for match in matches]
				for x in results:
					st = re.sub(rexrepl(x),r'<strong>'+x[8:-1]+'</strong>',st, re.U | re.I)
				
				matches = remph.finditer(st)
				results = [match.group(0) for match in matches]
				for x in results:
					st = re.sub(rexrepl(x),r'<em>'+x[6:-1]+'</em>',st, re.U | re.I)

				matches = rtextsc.finditer(st)
				results = [match.group(0) for match in matches]
				for x in results:
					st = re.sub(rexrepl(x),r'<span class="sc">'+x[8:-1]+'</span>',st, re.U | re.I)

				matches = racc.finditer(st)
				results = [match.group(0) for match in matches]
				for x in results:
					st = re.sub(rexrepl(x),x[5:-1]+'&#769;',st, re.U | re.I)

				matches = rgraph.finditer(st)
				results = [match.group(0) for match in matches]
				for x in results:
					w = ""
					h = ""
					if rgraphwidth.search(x):
						w = u' ' + rgraphwidth.search(x).group(0)[:6] + u'"' + rgraphwidth.search(x).group(0)[6:] + u'"'
					if rgraphheight.search(x):
						h = u' ' + rgraphheight.search(x).group(0)[:7] + u'"' + rgraphheight.search(x).group(0)[7:] + u'"'
					z = re.sub(ur'\\includegraphics(\[.*?\])?\{','',x, re.U)
					z = re.sub(ur'\}','',z, re.U)
					z = u'<img src="' + z + u'"' + w + h + u'/>'
					st = re.sub(rexrepl(x),z,st, re.U | re.I)

				# ruling out question numbering:
				if rtour.search(st):
					# print('RTOUR match on line: '+st)
					st = u"<h2>Тур "+unicode(tcount)+u".</h2>"
					tcount += 1
				if rqu.search(st):
					# print('RQU match on line: '+st)
					spoiled = False
					qu = rqu.search(st).group(0)
					pref = u"\n" + div +u"<strong>Вопрос "+unicode(qcount)+u": </strong>"
					#parag = True
					st = st[len(qu):]
					if st[-1:] == u'}': #если двери закрываются, делаем перенос
						postf = br
					qcount +=1
				# 	print(unicode(pref)+st)
				if ran.search(st):
					# print('RAN match on line: '+st)
					an = ran.search(st).group(0)
					pref = u'<strong>Ответ: </strong>' + ppresp()
					st = st[len(an):]
					if st[-1:] == u'}': #если двери закрываются, делаем перенос
						postf = br
					spoiled = True
				if rza.search(st):
					# print('RZA match on line: '+st)
					za = rza.search(st).group(0)
					pref = u'<strong>Зачёт: </strong>' + ppresp()
					st = st[len(za):]
					if st[-1:] == u'}': #если двери закрываются, делаем перенос
						postf = br
					spoiled = True
				if rnza.search(st):
					# print('Rnza match on line: '+st)
					nza = rnza.search(st).group(0)
					pref = u'<strong>Незачёт: </strong>' + ppresp()
					st = st[len(nza):]
					if st[-1:] == u'}': #если двери закрываются, делаем перенос
						postf = br
					spoiled = True
				if rco.search(st):
					# print('Rco match on line: '+st)
					co = rco.search(st).group(0)
					if mode=="standard + spoilers":
						spwrap = u"span"
					pref = u'<strong>Комментарий: </strong>' + ppresp()
					st = st[len(co):]
					if st[-1:] == u'}': #если двери закрываются, делаем перенос
						postf = br
					spoiled = True
				if rsos.search(st):
					# print('Rsos match on line: '+st)
					sos = rsos.search(st).group(0)
					if mode=="standard + spoilers":
						spwrap = u'div style="margin: 0; padding: 0;"'
					pref = u'<strong>Источники: </strong>' + ppresp()
					st = st[len(sos):]
					if st[-1:] == u'}': #если двери закрываются, делаем перенос
						postf = br
					spoiled = True
				if rso.search(st):
					# print('Rso match on line: '+st)
					so = rso.search(st).group(0)
					pref = u'<strong>Источник: </strong>' + ppresp()
					st = st[len(so):]
					if st[-1:] == u'}': #если двери закрываются, делаем перенос
						postf = br
					spoiled = True
				if raus.search(st):
					# print('Rau match on line: '+st)
					aus = raus.search(st).group(0)
					if mode=="standard + spoilers":
						spwrap = u"span"
					spoiled = False
					pref = pref + u'<strong>Авторы: </strong>'
					while st[-1:] == u'}':
						st = st[:-1]
					st = st[len(aus):]
					postf = postf + div2 + u"\n"
				if rau.search(st):
					# print('Rau match on line: '+st)
					au = rau.search(st).group(0)
					if mode=="standard + spoilers":
						spwrap = u"span"
					spoiled = False
					pref = pref + u'<strong>Автор: </strong>'
					while st[-1:] == u'}':
						st = st[:-1]
					st = st[len(au):]
					postf = postf + div2 + u"\n"
				# end section
				#print(pref + st)
				if re.search(ur'<li>',st):
					postf = postf + u"\n"
				if re.search(r'\\\*',st): #parag == True or 
					st = re.sub(ur'(?<!</li>)\\\\\*',br,st)
					st = re.sub(ur'\\\\\*',u'',st)
					# if not re.search(ur'<li>',st):
					# 	postf = postf + br
				# if st[-1:] == u'}' and not re.search(u"<br",postf):
				# 	postf = postf + br
				if (st[-1:] == u'}' and not re.search(rexrepl(br),postf)): # последняя строчка многострочного источника без енумерейта. двери закрылись, а бээра somehow ещё нет #(re.search(ur'<ol style="display: inline;">',st) or re.search(ur'</ol>',st) 
					postf = postf + br
				if (st[-1:] == u'}') and (spoiled == True): # закроем спойлер, если включен соотв. режим
					postf = pposp() + postf
				# else:
				# 	postf = postf + "\n"
				st = re.sub(r"\\((begin)|(end))\{.+?\}","",st) # вычищаем ненужные остатки теха
				st = re.sub(r"\\[a-zA-Z]+","",st)
				st = re.sub(r"(?<=[^\\])}","",st)
				st = re.sub(r"[\{\}]","",st)
				fw.write(pref + st + postf)
				#prevline = pref + st + postf #оказалась пока ненужной, ещё не было теста LJ как следует
			if(mode!="livejournal"):
				fw.write("\n"+r"</html>")
	print("Done!")
	os.system('pause')

if os.path.exists(args.filename):
	print("Opening file: "+args.filename.encode('ascii','replace'))
	print("Mode: "+mode)
	proc(args.filename)
else:
	print("Error: file "+args.filename.encode('ascii','replace')+" does not exist!")